#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

 int main(void)
{
    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern /* Subroutine */ int f_c();
    static double h__;
    static int i__, j, l, m;
    static double q, y[2], h0;
    static int k0;
    static double x1, ay[56] /* was [2][14][2] */, dy[2], xk, xn,
	    yn[2];
    static int nx;
    static double xs[3], yt[2];
    static int kp1, kp2, kp3;
    static double rab[457], ady[52] /* was [2][13][2] */, dyn[2], dyt[2],
	    ad2y[48] /* was [2][12][2] */;
    int de88d_c( );
    static double dely[2];
    static int imax;
    static double deldy[2];
    static int iordy, iniap0, iniapr;
    int i__1, i__2, i__3, i__4;

    m = 2;
    q = .5;
    xn = 0.f;
    yn[0] = cos(q) + 3.;
    yn[1] = -sin(q) + 2.;
    dyn[0] = q * 2. * sin(q);
    dyn[1] = q * 2. * cos(q);
    xk = 1.;
    iordy = 2;
    h0 = .5;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    k0 = 11;
    imax = 13;
    for (iniap0 = 1; iniap0 <= 2; ++iniap0) {
	iniapr = iniap0;
	h__ = h0;

	de88d_c((U_fp)f_c, &m, &xn, yn, dyn, &xk, &k0, &iniapr, &imax, &iordy, &
		h__, y, dy, &nx, xs, ay, ady, ad2y, rab);

	dely[0] = yt[0] - y[0];
	dely[1] = yt[1] - y[1];
	deldy[0] = dyt[0] - dy[0];
	deldy[1] = dyt[1] - dy[1];

    printf("\n ------------------------------------------------------------\n");
    printf("\n nx=%3i  xs=\n", nx);
    printf("\n %21.14e %21.14e %21.14e\n\n", xs[0], xs[1], xs[2]);

    printf("\n h0=%21.14e k0=%3i iniapr= %1i imax=%3i iordy=%1i \n\n",h0,k0,iniapr,imax, iordy);

    printf("\n y= %21.14e %21.14e\n",y[0],y[1]);
    printf("\n yt=%21.14e %21.14e\n",yt[0],yt[1]);
    printf("\n dely= %23.14e %23.14e \n\n", dely[0], dely[1]);

    printf("\n dy= %21.14e %21.14e\n",dy[0],dy[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0],dyt[1]);
    printf("\n deldy= %23.14e %23.14e \n", deldy[0], deldy[1]);

	kp3 = k0 + 3;
	kp2 = k0 + 2;
	kp1 = k0 + 1;

	i__1 = nx;
	for (i__ = 1; i__ <= i__1; ++i__) {

    printf("\n\n                    COEFFICIENTS AY, ADY AND AD2Y ON %3i SEGMENT \n", i__);
    printf("\n                            Chebyshev coefficients \n");
    printf("\n              for Y                   for  Y'                for Y'' \n");

	    i__2 = m;
	    for (l = 1; l <= i__2; ++l) {

    printf("\n\n   FOR %2i COMPONENT\n", l);

		i__3 = kp1;
		for (j = 1; j <= i__3; ++j) {
		    i__4 = j - 1;

         printf("\n %3i %23.14e %23.14e %23.14e", i__4, ay[l + (j + i__ * 14 << 1) - 31],
               ady[l + (j + i__ * 13 << 1) - 29], ad2y[l + (j + i__ * 12 << 1) - 27]);
		}
         printf("\n %3i %23.14e %23.14e \n %3i %23.14e", kp1, ay[l + (kp2 + i__ * 14 << 1) - 31],
                ady[l + (kp2 + i__ * 13 << 1) - 29],
                kp2, ay[l + (kp3 + i__ * 14 << 1) - 31] );
	    }
	}
    }
    return 0;
} /* main */

/* Subroutine */ int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double);

    /* Local variables */
    static real q;

    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    q = .5f;
/* Computing 2nd power */
    d__1 = (1. - exp(3. - y[1] + dy[2] * .5 / q)) / (*x + 1.);
    z__[1] = q * -2. * dy[2] - d__1 * d__1;
/* Computing 2nd power */
    d__1 = dy[2] - q * 2. * (y[1] - 3.);
    z__[2] = q * 2. * dy[1] - d__1 * d__1;
    return 0;
} /* f_c */
